<?

// -----------------------------------------------
// exit_local()
// -----------------------------------------------
function exit_local($print_err = 1) {
    drop_temp_table($print_err);
    exit;
}

// -----------------------------------------------
// print_db_error($str)
// -----------------------------------------------
function print_db_error($str){
    print "Critical database init error: $str<br>\n";
    exit;
}


// -----------------------------------------------
// print_error_local($str)
// -----------------------------------------------
function print_error_local($str){
    global $error;
    
    $error=$str;
    print_template('error');
    print_template('bottom');
    
    exit_local(0);
}

// -----------------------------------------------
// get_dict_tab(word)
// -----------------------------------------------
function get_dict_tab($word) {
   global $dict_table;

   if (strlen($word)>16) return $dict_table[16];
   return $dict_table[strlen($word)];
}

// -----------------------------------------------
// is_stopword($word)
// -----------------------------------------------
function is_stopword($word) {
    global $DEBUG;
    global $stopword_arr;

    if ($stopword_arr[$word]) return ($stopword_arr[$word]);
    
    $query="SELECT count(*) FROM stopword WHERE word='$word'";
    if($DEBUG) echo $query,"<BR><HR>";

    if (!($res=query($query))) print_error_local('Query error: '.$query."\n<BR>".db_error());
  
    $row=fetch_row($res);
    free_result($res);

    $stopword_arr[$word]=$row[0];

    return ($row[0]);
} 

// -----------------------------------------------
// drop_temp_table()
// -----------------------------------------------
function drop_temp_table($print_err) {
    global $temp_table;
    global $DEBUG;
    global $error;
    
    if ($temp_table != "") {
       $drop_temp_query="DROP TABLE $temp_table";
       if($DEBUG) echo $drop_temp_query,"<BR><HR>";

       if (!query($drop_temp_query)) {           
           if (! $print_err) {
               print('Query error: '.$drop_temp_query."\n<BR>".db_error());
	   } else {
	       $error='Query error: '.$drop_temp_query."\n<BR>".db_error();
	       print_template('error');
               print_template('bottom');
	   }       
           exit();     
       }
    }
}

// -----------------------------------------------
// track_query($query,$time,$found)
// -----------------------------------------------
function track_query($query,$time,$found) {
	global $trackquery;
        global $DEBUG;

	if ($trackquery != 'yes') return;

	$q="INSERT INTO qtrack VALUES ( '$query', $time, $found)";
        if($DEBUG) echo $q,"<BR><HR>";
                         
	if (!query($q)) print('Query error: '.$q."\n<BR>".db_error());
}

// -----------------------------------------------
// format_lastmod($lastmod)
// -----------------------------------------------
function format_lastmod($lastmod) {
	global $db_format;

	$temp=$lastmod;
	if ($db_format == '3.1') {
		if (!$temp) $temp = 'undefined';
		else $temp = strftime('%a, %d %b %Y %H:%M:%S %Z',$temp);
	} else {
		if ($temp == '') $temp = 'undefined';
	}

	return $temp;
}

// -----------------------------------------------
// format_dp($dp)
// -----------------------------------------------
function format_dp($dp) {
	$result=0;

	while ($dp != '') {		
		if (preg_match('/^([\-\+]?\d+)([sMhdmy]?)/',$dp,$param)) {			
			switch ($param[2]) {
				case 's':  $multiplier=1; break;
                                case 'M':  $multiplier=60; break;
                                case 'h':  $multiplier=3600; break;
                                case 'd':  $multiplier=3600*24; break;
                                case 'm':  $multiplier=3600*24*31; break;
                                case 'y':  $multiplier=3600*24*365; break;
				default: $multiplier=1;
			}

			$result += $param[1]*$multiplier;
                        $dp=preg_replace("/^[\-\+]?\d+$param[2]/",'',$dp);
		} else {
			return 0;
		}
	}

	return $result;
}

// -----------------------------------------------
// format_userdate($date)
// -----------------------------------------------
function format_userdate($date) {
	$result=0;

	if (preg_match('/^(\d+)\/(\d+)\/(\d+)$/',$date,$param)) {
		$day=$param[1];
		$mon=$param[2];
		$year=$param[3];

		$result=mktime(0,0,0,$mon,$day,$year);
	}

	return $result;
}

// -----------------------------------------------
// load_cs($cat)
// -----------------------------------------------
function load_cs($cat) {
	global $DEBUG;
	global $self;
        global $self;

        $query="SELECT path,link,name
                  FROM categories
                 WHERE path LIKE '$cat"."__'
                 ORDER BY NAME ASC";

        if($DEBUG) echo $query,"<BR><HR>";
                         
	if (!($res=query($query))) print('Query error: '.$query."\n<BR>".db_error());

	while($row=fetch_row($res)) {
		$path=$row[0];
		$link=$row[1];
		$name=$row[2];

		if (substr($path,strlen($path)-2,2)=='@@') {
			$result .= "<a href=\"$self?cat=$link\">@ $name</a><br>\n";
		} else {
			$result .= "<a href=\"$self?cat=$path\">$name</a><br>\n";
		}
	}
	free_result($res);

	return $result;
}

// -----------------------------------------------
// load_cp($cat)
// -----------------------------------------------
function load_cp($cat) {
	global $DEBUG;
	global $self;

   	$link_path=$cat;
   	$link_name='';

   	while ($link_path!='') {
   		$query="SELECT name FROM categories WHERE path='$link_path'";
		
		if($DEBUG) echo $query,"<BR><HR>";	

                if (!($res=query($query))) {
   			print_error_local('Query error: '.$query."\n<BR>".db_error());
   		}

   		$row=fetch_row($res);
   		free_result($res);

   		if (!$row) {
   			$link_path=substr($link_path,0,strlen($link_path)-2);
   			continue;
   		}

   		$row[0]=htmlspecialchars($row[0]);

   		$link_name = " > <a href=\"$self?cat=$link_path\">$row[0]</a>".$link_name;

   		$link_path=substr($link_path,0,strlen($link_path)-2);
   	}

   	$query="SELECT name FROM categories WHERE path='' OR path IS NULL";

	if($DEBUG) echo $query,"<BR><HR>";	

        if (!($res=query($query))) {
  		print_error_local('Query error: '.$query."\n<BR>".db_error());
  	}

  	$row=fetch_row($res);
  	free_result($res);

  	if ($row) {
  		$row[0]=htmlspecialchars($row[0]);	
  		$link_name = " > <a href=\"$self?cat=\">$row[0]</a>".$link_name;
  	} else {
  		$link_name='';
  	}

   	return $link_name;
}


?>
